<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_IntCodeAttr1 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_IntCodeAttr1 extends AbstractStructArrayBase
{
    /**
     * The Supplement
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_IntCodeAttr[]
     */
    public $Supplement;
    /**
     * Constructor method for ArrayOfJPSOAP_IntCodeAttr1
     * @uses ArrayOfJPSOAP_IntCodeAttr1::setSupplement()
     * @param \StructType\JPSOAP_IntCodeAttr[] $supplement
     */
    public function __construct(array $supplement = array())
    {
        $this
            ->setSupplement($supplement);
    }
    /**
     * Get Supplement value
     * @return \StructType\JPSOAP_IntCodeAttr[]|null
     */
    public function getSupplement()
    {
        return $this->Supplement;
    }
    /**
     * This method is responsible for validating the values passed to the setSupplement method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSupplement method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSupplementForArrayConstraintsFromSetSupplement(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_IntCodeAttr1SupplementItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_IntCodeAttr1SupplementItem instanceof \StructType\JPSOAP_IntCodeAttr) {
                $invalidValues[] = is_object($arrayOfJPSOAP_IntCodeAttr1SupplementItem) ? get_class($arrayOfJPSOAP_IntCodeAttr1SupplementItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_IntCodeAttr1SupplementItem), var_export($arrayOfJPSOAP_IntCodeAttr1SupplementItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Supplement property can only contain items of type \StructType\JPSOAP_IntCodeAttr, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Supplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_IntCodeAttr[] $supplement
     * @return \ArrayType\ArrayOfJPSOAP_IntCodeAttr1
     */
    public function setSupplement(array $supplement = array())
    {
        // validation for constraint: array
        if ('' !== ($supplementArrayErrorMessage = self::validateSupplementForArrayConstraintsFromSetSupplement($supplement))) {
            throw new \InvalidArgumentException($supplementArrayErrorMessage, __LINE__);
        }
        $this->Supplement = $supplement;
        return $this;
    }
    /**
     * Add item to Supplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_IntCodeAttr $item
     * @return \ArrayType\ArrayOfJPSOAP_IntCodeAttr1
     */
    public function addToSupplement(\StructType\JPSOAP_IntCodeAttr $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_IntCodeAttr) {
            throw new \InvalidArgumentException(sprintf('The Supplement property can only contain items of type \StructType\JPSOAP_IntCodeAttr, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Supplement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Supplement
     */
    public function getAttributeName()
    {
        return 'Supplement';
    }
}
